//This Software Created by Muhammad Arshad Latti  from Sargodha (Pakistan)
//E-Mail :: arshadlatti@gmail.com 
//Web Page :: http://www.geocities.com/arshadlati
//You can download complied and source version at  http://www.geocities.com/arshadlati/Projects.htm

#include "Desk_Time.h"

// global variables 
HINSTANCE hInst; 
HWND MainWin,hAboutDlg;
HMENU hMenu ;
BOOL bUser=FALSE,bColon=FALSE;
HICON hIco;
HBITMAP hBmpMemBack,hBmpBack,hBmpNum,hBmpColon,hBmpAm,hBmpPm;

// register main window class and display about dialog later about dialog will 
// hide it self
int  APIENTRY WinMain( HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
  WNDCLASS wc;

  hInst = hInstance; // save handle to an instance for later use             

   wc.style = CS_NOCLOSE ;// may NULL or 0 ???
   wc.lpfnWndProc = MainWndProc; 
   wc.cbClsExtra = 0;
   wc.cbWndExtra = 0;
   wc.hInstance = hInstance;
   wc.hCursor = LoadCursor( NULL, IDC_ARROW );
   wc.hIcon =NULL;
   wc.hbrBackground = (HBRUSH)( COLOR_BTNFACE + 1 );
   wc.lpszMenuName = NULL;
   wc.lpszClassName = "Desk_Time";

   if( ! RegisterClass( &wc ) )    
      return( FALSE );
	
   // display About dialog box
  	DialogBox(hInstance, (LPCTSTR)IDD_ABOUT, 0, (DLGPROC)DlgProcAbout);                                        
   return(0);           

}

LRESULT CALLBACK DlgProcAbout(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{

	switch (message)
	{
	case WM_INITDIALOG:// WM_INITDIALOG message  is sent before displaying the dialog

		//calling InitCommonControls for  windows xp visual styles
		InitCommonControls();

		//load a clock icon for about dialog and set this icon to dialog
		hIco=LoadIcon(hInst,MAKEINTRESOURCE(IDI_MAIN));
		SendMessage(hWnd,WM_SETICON,ICON_BIG,(LPARAM)hIco);
		
		// create main window where we will display the time
		 MainWin = CreateWindow( "Desk_Time", NULL,
                           WS_POPUP | WS_VISIBLE, 
                           CW_USEDEFAULT, CW_USEDEFAULT, 127, 36,
						   hWnd, NULL, hInst, NULL );

		 // create a timer event for first hiding about dialog and setting main window to background
		 SetTimer(hWnd,1,1,NULL);

		 // save dialog handle for later use
		 hAboutDlg=hWnd;
		return true;

	case WM_COMMAND:
          switch (LOWORD (wParam))
          {
		  case IDC_CMD_OK:// Ok button clicked by someone on about dialog

		// hide about dialog when someone click on ok button
		ShowWindow(hWnd,SW_HIDE); 
		bUser=FALSE; 
		  }
		break;

		case WM_TIMER: // signal by timer we must act on it to display time on main winow
			
			
			// before we display time we must check if about dialog box is visible and if not displayed by user
			// then that startup of our application so  take action and hide about dialog box + load main
			// window x,y position from registry  + kill first timer and set new one for  one second

			if (bUser==FALSE && IsWindowVisible(hWnd) !=0){
			ShowWindow(hWnd,SW_HIDE);
			LoadPostion();
			KillTimer(hWnd,1);
			SetTimer(hWnd,1,1000,NULL);
			}
			else
			{
				
				// change colon flag every second  
				if (bColon==FALSE)
					bColon=TRUE;
				else
					bColon=FALSE;

			// force main window to redraw time
			InvalidateRect(MainWin,NULL,TRUE);

			}
		break;

	case WM_CLOSE:
		PostQuitMessage(0);
		DestroyWindow(hWnd);
		break;
	case WM_DESTROY:
			KillTimer(hWnd,1);// kill timer before exit
			PostQuitMessage(0);
			DestroyWindow(hWnd);
		break;
	}
	return FALSE;
}

LRESULT CALLBACK MainWndProc( HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
 switch(uMsg )
   {
	 case WM_CREATE:// our main window is created now load bitmap and  Menu
		  LoadBitmaps();
          hMenu = LoadMenu (hInst,  MAKEINTRESOURCE(IDR_MENU1)) ;
          hMenu = GetSubMenu (hMenu, 0) ;
          return 0 ;

	 case WM_NCHITTEST: 
				// windows sent this message for  checking where mouse is
				// in our main window if mouse right button is pressed when 
				// checking then we say that client area by  returning HTCLIENT
				// else we tell windows its caption by returning HTCAPTION
			//*v2 Right click now work correctly
		 	 	if (GetKeyState( VK_RBUTTON ) < 0)
					return( HTCLIENT);
				else
					return( HTCAPTION );
	

     case WM_RBUTTONUP:// user right click in main window so display menu
		POINT        point ;
		point.x = LOWORD(lParam); 
		point.y = HIWORD(lParam); 
		ClientToScreen (hwnd, &point) ;
		TrackPopupMenu (hMenu, TPM_RIGHTBUTTON, point.x, 
								point.y, 0, hwnd, NULL) ;
	     return 0 ;

		case WM_COMMAND:
          switch (LOWORD (wParam))
          {
		  case ID_MENU_EXIT:// exit menu item clicked
			  PostQuitMessage( 0 );
			  	break;	
		  case ID_MENU_ABOUTDESKTOPTIME:// about desktop time menu item is clicked 
			 
		// show about dialog box and set flag (bUser) to true else dialog will hidden by timer
			ShowWindow(hAboutDlg,SW_SHOW); 
			bUser=TRUE;
			  	break;	
		  }
		  	break;	

		case WM_PAINT:  //WM_PAINT sent and now paint time	
				PAINTSTRUCT Ps;
				HDC hDC;
				hDC = BeginPaint( hwnd, &Ps );
				PaintTime(hDC);
				EndPaint( hwnd, &Ps );
				return( TRUE );

		case WM_DESTROY:

		// before exit save x,y position of main window in registry
		SavePostion();	

		unLoadBitmaps();
		PostQuitMessage( 0 );             
		break;

      default:
         return( DefWindowProc( hwnd, uMsg, wParam, lParam ) );
   }
	return( FALSE );
}

// SavePostion Function save x,y position of main window in registry
void SavePostion(void)
{
	RECT rc;
	HKEY keyHandle;
	DWORD disposition;

	GetWindowRect(MainWin,&rc);

	RegCreateKeyEx(HKEY_CURRENT_USER,
    "Software\\Arshad Latti\\Desktop Time",0, 
	NULL, REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,
	NULL, &keyHandle,&disposition);

	RegSetValueEx(keyHandle, "Postion",
    0, REG_BINARY, (CONST BYTE *) &rc,
    sizeof(RECT));

	RegCloseKey(keyHandle);
}

// LoadPostion Function read x,y position of main window from registry and apply them
void LoadPostion(void)
{
	 RECT rc;
	 HKEY keyHandle;
	 DWORD disposition;

	RegCreateKeyEx(HKEY_CURRENT_USER,
    "Software\\Arshad Latti\\Desktop Time",
    0, NULL, REG_OPTION_NON_VOLATILE,
    KEY_ALL_ACCESS, NULL, &keyHandle,&disposition);

if ( disposition==REG_OPENED_EXISTING_KEY)
{
	disposition=sizeof(RECT);

	RegQueryValueEx(keyHandle,"Postion",NULL, 
		NULL,(BYTE *)&rc,&disposition);
}
else
{
	rc.left=100;
	rc.top=100;
}
// before applying x,y check if x or y value is out of current screen x,y
	if (GetSystemMetrics(SM_CXSCREEN)< rc.left || 
					GetSystemMetrics(SM_CYSCREEN) < rc.top)
	{
		rc.left=50;
		rc.top=50;
	}


	SetWindowPos(MainWin,HWND_BOTTOM,rc.left,rc.top,0,0,SWP_NOSIZE);

	RegCloseKey(keyHandle);

}

// load bitmaps for our application
void LoadBitmaps(void)
{
   hBmpMemBack = LoadBitmap( hInst, MAKEINTRESOURCE(IDB_BACK) );
   hBmpBack = LoadBitmap( hInst, MAKEINTRESOURCE(IDB_BACK) );
   hBmpNum = LoadBitmap( hInst, MAKEINTRESOURCE(IDB_NUM) );
   hBmpColon = LoadBitmap( hInst, MAKEINTRESOURCE(IDB_COLON) );
   hBmpAm = LoadBitmap( hInst, MAKEINTRESOURCE(IDB_AM) );
   hBmpPm= LoadBitmap( hInst, MAKEINTRESOURCE(IDB_PM) );

}

// delete all loaded bitmaps
void unLoadBitmaps(void)
{
	DeleteObject( hBmpMemBack );
	DeleteObject( hBmpBack );
	DeleteObject(hBmpNum );
	DeleteObject( hBmpColon );
	DeleteObject(hBmpAm );
	DeleteObject( hBmpPm );
}

// paint time on main window
void PaintTime(HDC hdcMain)
{

	HDC     hdcMemBack;
	HDC     hdcBack;
    HDC     hdcNum;
	HDC     hdcColon;
    HDC     hdcAm;
	HDC     hdcPm;
	
	SYSTEMTIME st;
		
		// get time 
		GetLocalTime(&st);

		// create memory device context 
		hdcMemBack= CreateCompatibleDC( hdcMain);
		hdcBack= CreateCompatibleDC( hdcMain);
		hdcNum= CreateCompatibleDC( hdcMain);
		hdcColon= CreateCompatibleDC( hdcMain);
		hdcAm= CreateCompatibleDC( hdcMain);
		hdcPm= CreateCompatibleDC( hdcMain);
		
		// select bitmaps into memory device context
		SelectObject( hdcMemBack, hBmpMemBack );
		SelectObject( hdcBack, hBmpBack );
		SelectObject( hdcNum, hBmpNum );
		SelectObject( hdcColon, hBmpColon );
		SelectObject( hdcAm, hBmpAm );
		SelectObject( hdcPm, hBmpPm );


	// start paint time  by first digit 1 or nothing 
	if (st.wHour==10 || st.wHour==11 || st.wHour==12 || st.wHour==22 || st.wHour==23 || st.wHour==0)
		DrawNum(hdcBack,hdcNum,1,10);
	else
	BitBlt( hdcBack, 0, 0, 127,36, 
								hdcMemBack, 0, 0, SRCCOPY );

	//paint colon or not
	if (bColon==TRUE)
  BitBlt( hdcBack, 48, 9, 7,19, 
							hdcColon, 0, 0, SRCCOPY );
  else
  BitBlt( hdcBack, 48, 9, 7,19, 
							hdcColon, 0,19, SRCCOPY );
		
	//paint AM or PM
		if (st.wHour>11)
		BitBlt( hdcBack, 96, 5, 21,25, 
									hdcPm, 0,0, SRCCOPY );
		else
		BitBlt( hdcBack, 96, 5, 21,25, 
									hdcAm, 0,0, SRCCOPY );


// draw 2,3,4 digit 
DrawNum(hdcBack,hdcNum,Get2nd_Num(st.wHour),30);
DrawNum(hdcBack,hdcNum,Get3rd_Num(st.wMinute),55);
DrawNum(hdcBack,hdcNum,Get4th_Num(st.wMinute),75);

	//final step
	BitBlt( hdcMain, 0, 0, 127,36, 
								hdcBack, 0, 0, SRCCOPY );

		DeleteDC( hdcMemBack );
		DeleteDC( hdcBack );
		DeleteDC( hdcNum );
		DeleteDC( hdcColon );
		DeleteDC( hdcAm );	
		DeleteDC( hdcPm );

}

// draw digit (0-9) 
void DrawNum(HDC hdcTarget,HDC hdcMemBmpNum,WORD wNum,int x)
{
	int nxSrc;
	 switch(wNum )
   {
	 case 1:
		nxSrc=18;
		break;
	 case 2:
		nxSrc=36;
		break;
	 case 3:
		nxSrc=54;
		break;
	 case 4:
		nxSrc=72;
		break;
	 case 5:
		nxSrc=90;
		break;
	 case 6:
		nxSrc=108;
		break;
	 case 7:
		nxSrc=126;
		break;
	 case 8:
		nxSrc=144;
		break;
	 case 9:
		nxSrc=162;
		break;
	 case 0:
		nxSrc=0;
		break;

   }
   	 BitBlt( hdcTarget, x, 5, 18,26, 
							 hdcMemBmpNum, nxSrc,0, SRCCOPY );
}

// get 2nd digit of hour(0-9)
WORD Get2nd_Num(WORD wHour)
{
	WORD whour;
	whour=wHour;
if (whour>12 && whour<22)
	whour-=12;
else
{
	 switch(whour )
   {

	 case 10:
		whour=0;
		break;
	 case 11:
		whour=1;
		break;
	 case 12:
		whour=2;
		break;


	 case 22:
		whour=0;
		break;
	 case 23:
		whour=1;
		break;
	 case 0:
		whour=2;
		break;
   }
}
return (whour);
}

// get first digit of Minutes(0-5)
WORD Get3rd_Num(WORD wMinute)
{
	WORD wMin;
	wMin=wMinute;
	if (wMinute <10)
		return (0);
	if (wMinute <20)
		return (1);
	if (wMinute <30)
		return (2);
	if (wMinute <40)
		return (3);
	if (wMinute <50)
		return (4);
	return (5);
}


// get 2nd digit of Minutes (0-9)
WORD Get4th_Num(WORD wMinute)
{
	WORD wMin;
	wMin=wMinute;

if (wMinute==0 || wMinute==10 || wMinute==20 || wMinute==30 || wMinute==40 || wMinute==50)
return (0);

if (wMinute>0 && wMinute<10)
return (wMin);

if (wMinute>10 && wMinute<20)
return (wMin -10);

if (wMinute>20 && wMinute<30)
return (wMin -20);

if (wMinute>30 && wMinute<40)
return (wMin -30);

if (wMinute>40 && wMinute<50)
return (wMin -40);

if (wMinute>50 && wMinute<60)
wMin -=50;
return (wMin);
}